import { ConsoleFileHandler } from "./FileHandler";
import { downloadGeocaching } from "./downloadGeocaching";
import { downloadWhereigo } from "./downloadWhereigo";
import { parseFile } from "./parseFile";
(async () => {
  const type = process.argv[2];
  const arg = process.argv[3];
  let gcCode = "";
  let url = "";
  let filename = "";
  if (type == "gc") gcCode = arg;
  if (type == "url") url = arg;
  if (type == "file") filename = arg;
  if (gcCode) url = await downloadGeocaching(arg);
  if (url) filename = await downloadWhereigo(url);
  if (!filename) throw new Error("no file to parse");
  const fileHandler = new ConsoleFileHandler(filename);
  await parseFile(filename, fileHandler);
})();
