import { get } from "node:https";

export async function downloadGeocaching(code: string) {
  const data: string = await new Promise((resolve) => {
    get(
      "https://www.geocaching.com/geocache/" + code.toUpperCase(),
      function (res) {
        let data = "";
        res.on("data", function (chunk) {
          data += chunk;
        });
        res.on("end", function () {
          resolve(data);
        });
      },
    );
  });
  if (data.indexOf("premium-upgrade-widget") > -1)
    throw new Error(
      "Deze cache is premium, probeer de URL van de wherigo te gebruiken.",
    );
  const regex =
    /(?<=www\.wherigo\.com\/cartridge\/details\.aspx\?CGUID=)[0-9A-Fa-f-]{36}/g;
  const guids = data.match(regex);
  if (!guids || guids.length == 0)
    throw new Error(
      "Geen wherigo url gevonden op de geocaching pagina, probeer de url van de wherigo download pagina te gebruiken.",
    );
  return guids[0];
}
