import * as fs from "node:fs";
import { wrapper } from "axios-cookiejar-support";
import axios from "axios";
import { CookieJar } from "tough-cookie";
const jar = new CookieJar();
const client = wrapper(axios.create({ jar }));
export async function downloadWhereigo(id: string) {
  const username = process.env.USERNAME;
  const password = process.env.PASSWORD;
  if (!username || !password)
    throw new Error(
      "no username or password. Required for downloading whereigo's",
    );
  await client.get("https://www.wherigo.com/login/default.aspx");
  const loginResponse = await client.post(
    "https://www.wherigo.com/login/default.aspx",
    {
      __EVENTTARGET: "",
      ctl00$ContentPlaceHolder1$Login1$Login1$UserName: username,
      ctl00$ContentPlaceHolder1$Login1$Login1$Password: password,
      ctl00$ContentPlaceHolder1$Login1$Login1$LoginButton: "Sign In",
    },
    {
      headers: {
        "Content-Type": "application/x-www-form-urlencoded",
      },
    },
  );
  const regex =
    /<input name="__RequestVerificationToken" type="hidden" value="([-0-9\w]*)"/;
  const verificationToken = loginResponse.data.match(regex)[1];
  const downloadResponse = await client.post(
    "https://www.wherigo.com/cartridge/download.aspx?CGUID=" + id,
    {
      __EVENTTARGET: "",
      __EVENTARGUMENT: "",
      ctl00$ContentPlaceHolder1$uxDeviceList: "4",
      ctl00$ContentPlaceHolder1$btnDownload: "Download Now",
      __RequestVerificationToken: verificationToken,
    },
    {
      headers: {
        "Content-Type": "application/x-www-form-urlencoded",
      },
      responseType: "arraybuffer",
    },
  );

  fs.writeFileSync(__dirname + "/media/" + id + ".gwc", downloadResponse.data);
  return `${__dirname}/media/${id}.gwc`;
}
