export function gsub_wig(str: string) {
  const palette =
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789@.-~".split(
      "",
    );
  return str
    .split("")
    .map(function (char: string[0], charId: number) {
      if (palette.indexOf(char) > -1) {
        let p = palette.indexOf(char) + (charId % 8) + 9;
        if (p > 65) p -= 66;
        return palette[p];
      } else return char;
    })
    .join("");
}
export function ucode_wig(ucodenum: number) {
  try {
    return String.fromCharCode(ucodenum);
  } catch (e) {
    return "?";
  }
}
export function WWB_deobf(str: string) {
  const magic: { [key: string]: string } = {
    "\x01": "B",
    "\x02": "R",
    "\x03": "",
  };
  const palette =
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789@.-~".split(
      "",
    );
  let d = 0;
  str = str.replace(/&nbsp;/g, " ");
  str = str.replace(/&lt;/g, "\x04");
  str = str.replace(/&gt;/g, "\x05");
  str = str.replace(/&amp;/g, "\x06");
  return str
    .split("")
    .map(function (c) {
      let p = palette.indexOf(c);
      if (p > -1) {
        p -= (d % 8) + 9;
        if (p < 0) p += palette.length;
        c = palette[p];
      } else {
        const x = magic[c];
        if (x) c = x;
      }
      const x = c.charCodeAt(0);
      if (x > 127) d += 1;
      if (x > 2047) d += 1;
      d += 1;
      return c;
    })
    .join("");
}
